unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, MyFunc, JwwGaibu ;

type
  TForm1 = class(TForm)
    RadioButton1: TRadioButton;
    Edit1: TEdit;
    RadioButton2: TRadioButton;
    Edit2: TEdit;
    RadioButton3: TRadioButton;
    Edit3: TEdit;
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    RadioButton4: TRadioButton;
    Edit4: TEdit;
    RadioButton5: TRadioButton;
    Edit5: TEdit;
    Label2: TLabel;
    Edit6: TEdit;
    Label3: TLabel;
    Edit7: TEdit;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private 錾 }
    AppPath : string ;
    rm : integer ;
    r1,r2,r3,r4,r5,r6,r7 : double ;
    procedure OpenDatFile ;
    procedure SaveDatFile ;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// f[^t@Cǂݍ
procedure TForm1.OpenDatFile ;
var
   fn: string ;
   F : TextFile ;
   s : string ;
begin
   fn := ChangeFileExt(Application.ExeName,'.dat') ;
   rm := 0 ;
   r1 := 100.0;
   r2 := 100.0;
   r3 := 1.0;
   r4 := 0.0;
   r5 := 0.0;
   r6 := 0.001;
   r7 := 0.001;
   // ǂݍ
   if not(FileExists(fn)) then exit;
   try
      AssignFile(F, fn);
      FileMode := 0;
      Reset(F);

      ReadLn(F, s);     rm := SInt(s);
      ReadLn(F, s);     r1 := SDbl(s);
      ReadLn(F, s);     r2 := SDbl(s);
      ReadLn(F, s);     r3 := SDbl(s);

      if (EOF(F)) then begin
         CloseFile(F);
         exit ;
      end;

      ReadLn(F, s);     r4 := SDbl(s);
      ReadLn(F, s);     r5 := SDbl(s);
      ReadLn(F, s);     r6 := SDbl(s);
      ReadLn(F, s);     r7 := SDbl(s);

      CloseFile(F);
   except
      CloseFile(F);
   end;
end;

// f[^t@Cۑ
procedure TForm1.SaveDatFile ;
var
   fn: string ;
   F : TextFile ;
begin
   fn := ChangeFileExt(Application.ExeName,'.dat') ;
   try
      AssignFile(F, fn);
      ReWrite(F);

      WriteLn(F, IntToStr(rm));
      WriteLn(F, FloatToStr(r1));
      WriteLn(F, FloatToStr(r2));
      WriteLn(F, FloatToStr(r3));
      WriteLn(F, FloatToStr(r4));
      WriteLn(F, FloatToStr(r5));
      WriteLn(F, FloatToStr(r6));
      WriteLn(F, FloatToStr(r7));

      CloseFile(F);
   except
      CloseFile(F);
      if FileExists(fn) then DeleteFile(fn);
   end;
end;

// N
procedure TForm1.FormShow(Sender: TObject);
begin
   Form1.Left := Mouse.CursorPos.X - Form1.Width div 2;
   Form1.Top  := Mouse.CursorPos.Y - 4;
   if (Form1.Left < Form1.Monitor.Left) then Form1.Left := Form1.Monitor.Left ;
   if (Form1.Top  < Form1.Monitor.Top ) then Form1.Top  := Form1.Monitor.Top  ;
   if (Form1.Left > (Form1.Monitor.Left+Form1.Monitor.Width -Form1.Width)) then
      Form1.Left :=  Form1.Monitor.Left+Form1.Monitor.Width -Form1.Width  ;
   if (Form1.Top  > (Form1.Monitor.Top +Form1.Monitor.Height-Form1.Height)) then
      Form1.Top  :=  Form1.Monitor.Top +Form1.Monitor.Height-Form1.Height ;
   // ݒ
   InitJwwGaibu ;
   // vÔtH_擾܂
   AppPath := ExtractFilePath(Application.ExeName) ;
   // JWC_TEMP.TXTJ܂
   OpenTempFile(AppPath+'JWC_TEMP.TXT') ;
   // ݒ
   S_Init ;
   OpenDatFile ;
   RadioButton1.Checked := True ;
   case (rm) of
   1: RadioButton2.Checked := True ;
   2: RadioButton3.Checked := True ;
   3: RadioButton4.Checked := True ;
   4: RadioButton5.Checked := True ;
   end;
   Edit1.Text := FloatToStr(r1);
   Edit2.Text := FloatToStr(r2);
   Edit3.Text := FloatToStr(r3);
   Edit4.Text := FloatToStr(r4);
   Edit5.Text := FloatToStr(r5);
   Edit6.Text := FloatToStr(r6);
   Edit7.Text := FloatToStr(r7);
   Label1.Caption := '';
end;

// I
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   // JWC_TEMP.TXTۑ܂
   SaveTempFile(AppPath+'JWC_TEMP.TXT') ;
   // ŏI
   EndJwwGaibu ;
end;

// [OK]
procedure TForm1.Button1Click(Sender: TObject);
var
   i : integer ;
begin
   rm := 0 ;
   if (RadioButton2.Checked) then rm := 1;
   if (RadioButton3.Checked) then rm := 2;
   if (RadioButton4.Checked) then rm := 3;
   if (RadioButton5.Checked) then rm := 4;
   r1 := SDbl(Edit1.Text);
   r2 := SDbl(Edit2.Text);
   r3 := SDbl(Edit3.Text);
   r4 := SDbl(Edit4.Text);
   r5 := SDbl(Edit5.Text);
   r6 := SDbl(Edit6.Text);
   r7 := SDbl(Edit7.Text);
   if (r1 <= 0.0)or(r2 <= 0.0)or(r3 <= 0.0)or(r6 <= 0.0)or(r7 <= 0.0) then exit ;
   SaveDatFile ;
   // ύX
   Label1.Caption := '~f[^ύXł';
   Label1.Update ;
   for i:=0 to JW_EntCircN-1 do begin
      with JW_EntCirc[i] do begin
         case(rm)of
         0: begin
               cr := r1 ;
            end;
         1: begin
               cr := r2 * JG_LGrpScale[att.LGrp] ;
            end;
         2: begin
               cr := cr * r3 ;
            end;
         3: begin
               cr := cr + r4 ;
               if (cr < r6) then cr := r6;
            end;
         4: begin
               cr := cr + r5 * JG_LGrpScale[att.LGrp] ;
               if (cr < r7 * JG_LGrpScale[att.LGrp]) then
                  cr := r7 * JG_LGrpScale[att.LGrp];
            end;
         end;
      end;
   end;
   Label1.Caption := '~ʁEȉ~f[^ύXł';
   Label1.Update ;
   for i:=0 to JW_EntArcN-1 do begin
      with JW_EntArc[i] do begin
         case(rm)of
         0: begin
               cr := r1 ;
            end;
         1: begin
               cr := r2 * JG_LGrpScale[att.LGrp] ;
            end;
         2: begin
               cr := cr * r3 ;
            end;
         3: begin
               cr := cr + r4 ;
               if (cr < r6) then cr := r6;
            end;
         4: begin
               cr := cr + r5 * JG_LGrpScale[att.LGrp] ;
               if (cr < r7 * JG_LGrpScale[att.LGrp]) then
                  cr := r7 * JG_LGrpScale[att.LGrp];
            end;
         end;
      end;
   end;
   // 
   SendMem('hd');
   S_EntAll(-1,-1,-1,-1,-1,-1,-1,0, Label1);
   Label1.Caption := 't@Cł';
   Label1.Update ;
   Close ;
end;

// [Cancel]
procedure TForm1.Button2Click(Sender: TObject);
begin
   Close ;
end;

end.
